<template>
  <v-main class="app">
    <label-canvas
      v-if="source && analysis && actions"
      :get-label="actions.getLabel.bind(actions)"
      :sorted-labels="actions.getSortedLabels()"
      :is-focused="true"
      :source="source"
      :zoom="0.5"
    >
      <template #svgInjector>
        <canvas-source-base
          :analysis="analysis"
          :source="source"
          :signature="piece.signature"
        />
      </template>
      <template #default="{ canvas }">
        <b-seek-on-shift-click
          v-if="audioTrack"
          :canvas="canvas"
          :pages="source.pages"
          :pixel-unit="source.pixelUnit"
          @update:time="setTime($event)"
        />
        <b-canvas-cursor
          :pages="source.pages"
          :canvas="canvas"
          :pixel-unit="source.pixelUnit"
          :musical-time="musicalTime"
          :real-time="realTime"
        />
      </template>
    </label-canvas>
    <file-player-container
      ref="player"
      v-model="playing"
      :audio="audioTrack"
      :musical-time.sync="musicalTime"
      :real-time.sync="realTime"
    />
    <color-generator
      v-if="analysis"
      :analysis="analysis"
    />
  </v-main>
</template>

<script lang="ts">
import {
  Component, Vue, Prop, Ref,
} from 'vue-property-decorator';
import LabelCanvas from '@/components/canvas/LabelCanvas.vue';
import ColorGenerator from '@/components/canvas-addons/ColorGenerator.vue';
import BCanvasCursor from '@/components/behaviors/player/BCanvasCursor.vue';
import BSeekOnShiftClick from '@/components/behaviors/player/BSeekOnShiftClick.vue';

import type {
  Piece, Source, Audio, Onset, Second,
} from '@/data';
import { Analysis } from '@/data';

import { Client } from '@/client';
import type AnalysisActions from '@/logic/AnalysisActions';
import AnalysisActionsImpl from '@/logic/AnalysisActionsImpl';
import FilePlayerContainer from '@/components/players/FilePlayerContainer.vue';
import CanvasSourceBase from '@/components/canvas-sources/CanvasSourceBase.vue';

@Component({
  components: {
    CanvasSourceBase,
    LabelCanvas,
    ColorGenerator,
    BCanvasCursor,
    BSeekOnShiftClick,
    FilePlayerContainer,
  },
})
export default class DezrannCanvas extends Vue {
  @Prop({ default: 'bach-fugues/bwv847' })
  piecePath!: string;

  @Prop({ default: 'empty.dez' })
  analysisId!: string;

  @Prop({ default: 0 })
  sourceId!: number;

  @Prop({ default: 0 })
  audioIndex!: number;

  @Prop({ default: false })
  playing!: boolean;

  @Ref('track')
  track?: HTMLAudioElement;

  @Ref('player')
  player?: FilePlayerContainer;

  piece: Piece | null = null;

  source: Source | null = null;

  analysis: Analysis | null = null;

  actions: AnalysisActions | null = null;

  audioTrack: Audio | null = null;

  musicalTime: Onset = 0 as Onset;

  realTime: Second | null = null;

  async mounted() {
    const req = await this.client.loadPiece(this.piecePath, true);
    this.piece = req.data;
    this.audioTrack = this.piece.tracks[this.audioIndex];
    this.loadSource();
    this.loadAnalysis();
  }

  loadSource() {
    if (!this.piece) return;

    this.source = this.piece.sources[this.sourceId || 0];
    if (!this.source) throw new Error(`Could not load source: ${this.sourceId}`);
  }

  setTime(time: Onset) {
    this.player?.setMusicalTime(time);
  }

  async loadAnalysis() {
    if (!this.piece) return;

    if (this.analysisId) {
      const req = await this.client.loadAnalysis(this.piece, this.analysisId);
      if (req.isOk()) this.analysis = req.data;
      // eslint-disable-next-line no-console
      else console.error(req);
    }
    if (!this.analysis) this.analysis = new Analysis([]);

    this.actions = new AnalysisActionsImpl(this.piece, this.analysis);
  }

  get client(): Client {
    return new Client(
      'https://ws.dezrann.net/',
      'https://auth.dezrann.net/authenticate/',
      'https://dezauth.lifl.fr/changepw/',
      false,
      'static/resources',
    );
  }
}
</script>
